=== modified file 'drizzled/cursor.cc'
--- drizzled/cursor.cc	2011-06-23 10:02:30 +0000
+++ drizzled/cursor.cc	2011-06-23 10:47:03 +0000
@@ -680,7 +680,7 @@
      * or similar...
      */
     Session& session= *getTable()->in_use;
-    TransactionServices::singleton().truncateTable(session, *getTable());
+    TransactionServices::truncateTable(session, *getTable());
   }
 
   return result;
@@ -1261,10 +1261,9 @@
                                     const unsigned char *before_record,
                                     const unsigned char *after_record)
 {
-  TransactionServices &transaction_services= TransactionServices::singleton();
   Session *const session= table->in_use;
 
-  if (table->getShare()->getType() || not transaction_services.shouldConstructMessages())
+  if (table->getShare()->getType() || not TransactionServices::shouldConstructMessages())
     return false;
 
   bool result= false;
@@ -1281,7 +1280,7 @@
      * CREATE TABLE will commit the transaction containing
      * it).
      */
-    result= transaction_services.insertRecord(*session, *table);
+    result= TransactionServices::insertRecord(*session, *table);
     break;
   case SQLCOM_REPLACE:
   case SQLCOM_REPLACE_SELECT:
@@ -1310,20 +1309,20 @@
        * as the row to delete (this is the conflicting row), so
        * we need to notify TransactionService to use that row.
        */
-      transaction_services.deleteRecord(*session, *table, true);
+      TransactionServices::deleteRecord(*session, *table, true);
       /* 
        * We set the "current" statement message to NULL.  This triggers
        * the replication services component to generate a new statement
        * message for the inserted record which will come next.
        */
-      transaction_services.finalizeStatementMessage(*session->getStatementMessage(), *session);
+      TransactionServices::finalizeStatementMessage(*session->getStatementMessage(), *session);
     }
     else
     {
       if (before_record == NULL)
-        result= transaction_services.insertRecord(*session, *table);
+        result= TransactionServices::insertRecord(*session, *table);
       else
-        transaction_services.updateRecord(*session, *table, before_record, after_record);
+        TransactionServices::updateRecord(*session, *table, before_record, after_record);
     }
     break;
   case SQLCOM_INSERT:
@@ -1336,17 +1335,17 @@
      * an update.
      */
     if (before_record == NULL)
-      result= transaction_services.insertRecord(*session, *table);
+      result= TransactionServices::insertRecord(*session, *table);
     else
-      transaction_services.updateRecord(*session, *table, before_record, after_record);
+      TransactionServices::updateRecord(*session, *table, before_record, after_record);
     break;
 
   case SQLCOM_UPDATE:
-    transaction_services.updateRecord(*session, *table, before_record, after_record);
+    TransactionServices::updateRecord(*session, *table, before_record, after_record);
     break;
 
   case SQLCOM_DELETE:
-    transaction_services.deleteRecord(*session, *table);
+    TransactionServices::deleteRecord(*session, *table);
     break;
   default:
     break;

=== modified file 'drizzled/main.cc'
--- drizzled/main.cc	2011-06-22 21:57:14 +0000
+++ drizzled/main.cc	2011-06-23 10:47:03 +0000
@@ -369,14 +369,11 @@
   drizzle_rm_tmp_tables();
   errmsg_printf(error::INFO, _(ER(ER_STARTUP)), internal::my_progname, PANDORA_RELEASE_VERSION, COMPILATION_COMMENT);
 
-
-  TransactionServices &transaction_services= TransactionServices::singleton();
-
   /* Send server startup event */
   {
     Session::shared_ptr session= Session::make_shared(plugin::Listen::getNullClient(), catalog::local());
     setCurrentSession(session.get());
-    transaction_services.sendStartupEvent(*session);
+    TransactionServices::sendStartupEvent(*session);
     plugin_startup_window(modules, *session.get());
   }
 
@@ -401,7 +398,7 @@
   {
     Session::shared_ptr session= Session::make_shared(plugin::Listen::getNullClient(), catalog::local());
     setCurrentSession(session.get());
-    transaction_services.sendShutdownEvent(*session.get());
+    TransactionServices::sendShutdownEvent(*session.get());
   }
 
   {

=== modified file 'drizzled/plugin/schema_engine.cc'
--- drizzled/plugin/schema_engine.cc	2011-04-20 22:18:30 +0000
+++ drizzled/plugin/schema_engine.cc	2011-06-23 10:47:03 +0000
@@ -146,8 +146,7 @@
     if (success)
     {
       success_count++;
-      TransactionServices &transaction_services= TransactionServices::singleton();
-      transaction_services.allocateNewTransactionId();
+      TransactionServices::allocateNewTransactionId();
     }
   }
 };
@@ -161,8 +160,7 @@
 
   if (success_count)
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.allocateNewTransactionId();
+    TransactionServices::allocateNewTransactionId();
   }
 
   return (bool)success_count;
@@ -190,8 +188,7 @@
     if (success)
     {
       success_count++;
-      TransactionServices &transaction_services= TransactionServices::singleton();
-      transaction_services.allocateNewTransactionId();
+      TransactionServices::allocateNewTransactionId();
     }
   }
 };
@@ -201,13 +198,9 @@
                                       identifier::table::vector &dropped_tables,
                                       uint64_t &deleted)
 {
-  TransactionServices &transaction_services= TransactionServices::singleton();
-
   plugin::StorageEngine::getIdentifiers(session, identifier, dropped_tables);
 
-  for (identifier::table::vector::iterator it= dropped_tables.begin();
-       it != dropped_tables.end();
-       it++)
+  for (identifier::table::vector::iterator it= dropped_tables.begin(); it != dropped_tables.end(); it++)
   {
     boost::mutex::scoped_lock scopedLock(table::Cache::mutex());
 
@@ -224,7 +217,7 @@
       my_error(ER_TABLE_DROP, *it);
       return false;
     }
-    transaction_services.dropTable(session, *it, *message, true);
+    TransactionServices::dropTable(session, *it, *message, true);
     deleted++;
   }
 
@@ -284,8 +277,7 @@
     else
     {
       /* We've already verified that the schema does exist, so safe to log it */
-      TransactionServices &transaction_services= TransactionServices::singleton();
-      transaction_services.dropSchema(session, identifier, schema_message);
+      TransactionServices::dropSchema(session, identifier, schema_message);
     }
   } while (0);
 
@@ -337,8 +329,7 @@
 
   if (success_count)
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.allocateNewTransactionId();
+    TransactionServices::allocateNewTransactionId();
   }
 
   return success_count ? true : false;

=== modified file 'drizzled/plugin/transactional_storage_engine.h'
--- drizzled/plugin/transactional_storage_engine.h	2011-04-18 14:23:38 +0000
+++ drizzled/plugin/transactional_storage_engine.h	2011-06-23 10:47:03 +0000
@@ -63,15 +63,13 @@
 
   virtual int startTransaction(Session *session, start_transaction_option_t options)
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.registerResourceForTransaction(*session, this, this);
+    TransactionServices::registerResourceForTransaction(*session, this, this);
     return doStartTransaction(session, options);
   }
 
   virtual void startStatement(Session *session)
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.registerResourceForStatement(*session, this, this);
+    TransactionServices::registerResourceForStatement(*session, this, this);
     doStartStatement(session);
   }
 

=== modified file 'drizzled/plugin/xa_storage_engine.h'
--- drizzled/plugin/xa_storage_engine.h	2011-03-29 12:45:08 +0000
+++ drizzled/plugin/xa_storage_engine.h	2011-06-23 10:47:03 +0000
@@ -52,15 +52,13 @@
 
   int startTransaction(Session *session, start_transaction_option_t options)
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.registerResourceForTransaction(*session, this, this, this);
+    TransactionServices::registerResourceForTransaction(*session, this, this, this);
     return doStartTransaction(session, options);
   }
 
   void startStatement(Session *session)
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.registerResourceForStatement(*session, this, this, this);
+    TransactionServices::registerResourceForStatement(*session, this, this, this);
     doStartStatement(session);
   }
 

=== modified file 'drizzled/schema.cc'
--- drizzled/schema.cc	2011-04-23 21:05:33 +0000
+++ drizzled/schema.cc	2011-06-23 10:47:03 +0000
@@ -72,7 +72,6 @@
 
 bool create(Session &session, const message::Schema &schema_message, const bool is_if_not_exists)
 {
-  TransactionServices &transaction_services= TransactionServices::singleton();
   bool error= false;
 
   /*
@@ -123,7 +122,7 @@
     }
     else // Created !
     {
-      transaction_services.createSchema(session, schema_message);
+      TransactionServices::createSchema(session, schema_message);
       session.my_ok(1);
     }
   }
@@ -139,8 +138,6 @@
            const message::Schema &schema_message,
            const message::Schema &original_schema)
 {
-  TransactionServices &transaction_services= TransactionServices::singleton();
-
   /*
     Do not alter database if another thread is holding read lock.
     Wait for global read lock before acquiring session->catalog()->schemaLock().
@@ -172,7 +169,7 @@
 
     if (success)
     {
-      transaction_services.alterSchema(session, original_schema, schema_message);
+      TransactionServices::alterSchema(session, original_schema, schema_message);
       session.my_ok(1);
     }
     else

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-06-22 22:23:29 +0000
+++ drizzled/session.cc	2011-06-23 10:47:03 +0000
@@ -406,8 +406,7 @@
   }
 #endif
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.rollbackTransaction(*this, true);
+    TransactionServices::rollbackTransaction(*this, true);
   }
 
   BOOST_FOREACH(UserVars::reference iter, user_vars)
@@ -745,7 +744,6 @@
 {
   bool do_release= 0;
   bool result= true;
-  TransactionServices &transaction_services= TransactionServices::singleton();
 
   if (transaction.xid_state.xa_state != XA_NOTR)
   {
@@ -761,7 +759,7 @@
        * (Which of course should never happen...)
        */
       server_status&= ~SERVER_STATUS_IN_TRANS;
-      if (transaction_services.commitTransaction(*this, true))
+      if (TransactionServices::commitTransaction(*this, true))
         result= false;
       options&= ~(OPTION_BEGIN);
       break;
@@ -778,7 +776,7 @@
     case ROLLBACK_AND_CHAIN:
     {
       server_status&= ~SERVER_STATUS_IN_TRANS;
-      if (transaction_services.rollbackTransaction(*this, true))
+      if (TransactionServices::rollbackTransaction(*this, true))
         result= false;
       options&= ~(OPTION_BEGIN);
       if (result == true && (completion == ROLLBACK_AND_CHAIN))
@@ -805,7 +803,6 @@
 bool Session::endActiveTransaction()
 {
   bool result= true;
-  TransactionServices &transaction_services= TransactionServices::singleton();
 
   if (transaction.xid_state.xa_state != XA_NOTR)
   {
@@ -815,7 +812,7 @@
   if (options & (OPTION_NOT_AUTOCOMMIT | OPTION_BEGIN))
   {
     server_status&= ~SERVER_STATUS_IN_TRANS;
-    if (transaction_services.commitTransaction(*this, true))
+    if (TransactionServices::commitTransaction(*this, true))
       result= false;
   }
   options&= ~(OPTION_BEGIN);
@@ -1814,9 +1811,8 @@
     TODO: This should be fixed in later releases.
    */
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
     main_da().can_overwrite_status= true;
-    transaction_services.autocommitOrRollback(*this, is_error());
+    TransactionServices::autocommitOrRollback(*this, is_error());
     main_da().can_overwrite_status= false;
     transaction.stmt.reset();
   }

=== modified file 'drizzled/sql_delete.cc'
--- drizzled/sql_delete.cc	2011-06-22 20:05:58 +0000
+++ drizzled/sql_delete.cc	2011-06-23 10:47:03 +0000
@@ -403,7 +403,7 @@
     Safety, in case the engine ignored ha_enable_transaction(false)
     above. Also clears session->transaction.*.
   */
-  error= TransactionServices::singleton().autocommitOrRollback(session, error);
+  error= TransactionServices::autocommitOrRollback(session, error);
   session.options= save_options;
   return error;
 }

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2011-06-22 22:23:29 +0000
+++ drizzled/sql_insert.cc	2011-06-23 10:47:03 +0000
@@ -1768,8 +1768,7 @@
     */
     if (!table->getShare()->getType())
     {
-      TransactionServices &transaction_services= TransactionServices::singleton();
-      transaction_services.autocommitOrRollback(*session, 0);
+      TransactionServices::autocommitOrRollback(*session, 0);
       (void) session->endActiveTransaction();
     }
 

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2011-06-22 22:23:29 +0000
+++ drizzled/sql_parse.cc	2011-06-23 10:47:03 +0000
@@ -295,8 +295,7 @@
 
   /* If commit fails, we should be able to reset the OK status. */
   session->main_da().can_overwrite_status= true;
-  TransactionServices &transaction_services= TransactionServices::singleton();
-  transaction_services.autocommitOrRollback(*session, session->is_error());
+  TransactionServices::autocommitOrRollback(*session, session->is_error());
   session->main_da().can_overwrite_status= false;
 
   session->transaction.stmt.reset();

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2011-06-23 10:02:30 +0000
+++ drizzled/sql_table.cc	2011-06-23 10:47:03 +0000
@@ -197,8 +197,7 @@
         {
           if (message) // If we have no definition, we don't know if the table should have been replicated
           {
-            TransactionServices &transaction_services= TransactionServices::singleton();
-            transaction_services.dropTable(*session, identifier, *message, if_exists);
+            TransactionServices::dropTable(*session, identifier, *message, if_exists);
           }
         }
         else
@@ -1368,8 +1367,7 @@
 
   if (table_proto.type() == message::Table::STANDARD && not internal_tmp_table)
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.createTable(*session, table_proto);
+    TransactionServices::createTable(*session, table_proto);
   }
 
   return false;
@@ -1714,7 +1712,6 @@
   List<Item> field_list;
   Item *item;
   int result_code= 0;
-  TransactionServices &transaction_services= TransactionServices::singleton();
   const charset_info_st * const cs= system_charset_info;
 
   if (! session->endActiveTransaction())
@@ -1789,7 +1786,7 @@
       length= snprintf(buff, sizeof(buff), ER(ER_OPEN_AS_READONLY),
                        table_name.c_str());
       session->getClient()->store(buff, length);
-      transaction_services.autocommitOrRollback(*session, false);
+      TransactionServices::autocommitOrRollback(*session, false);
       session->endTransaction(COMMIT);
       session->close_thread_tables();
       session->lex().reset_query_tables_list(false);
@@ -1913,7 +1910,7 @@
         }
       }
     }
-    transaction_services.autocommitOrRollback(*session, false);
+    TransactionServices::autocommitOrRollback(*session, false);
     session->endTransaction(COMMIT);
     session->close_thread_tables();
     table->table=0;				// For query cache
@@ -1925,7 +1922,7 @@
   return false;
 
 err:
-  transaction_services.autocommitOrRollback(*session, true);
+  TransactionServices::autocommitOrRollback(*session, true);
   session->endTransaction(ROLLBACK);
   session->close_thread_tables();			// Shouldn't be needed
   if (table)
@@ -2016,8 +2013,7 @@
 
   if (success && not destination_identifier.isTmp())
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.createTable(session, new_table_message);
+    TransactionServices::createTable(session, new_table_message);
   }
 
   return success;

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2011-06-21 21:25:17 +0000
+++ drizzled/statement/alter_table.cc	2011-06-23 10:47:03 +0000
@@ -732,7 +732,6 @@
     Note that DISCARD/IMPORT TABLESPACE always is the only operation in an
     ALTER Table
   */
-  TransactionServices &transaction_services= TransactionServices::singleton();
   session->set_proc_info("discard_or_import_tablespace");
 
  /*
@@ -757,20 +756,20 @@
       break;
 
     /* The ALTER Table is always in its own transaction */
-    error= transaction_services.autocommitOrRollback(*session, false);
+    error= TransactionServices::autocommitOrRollback(*session, false);
     if (not session->endActiveTransaction())
       error= 1;
 
     if (error)
       break;
 
-    transaction_services.rawStatement(*session,
+    TransactionServices::rawStatement(*session,
                                       *session->getQueryString(),
                                       *session->schema());
 
   } while(0);
 
-  (void) transaction_services.autocommitOrRollback(*session, error);
+  (void) TransactionServices::autocommitOrRollback(*session, error);
   session->setDoingTablespaceOperation(false);
 
   if (error == 0)
@@ -1040,9 +1039,8 @@
 
       if (not error)
       {
-        TransactionServices &transaction_services= TransactionServices::singleton();
-        transaction_services.allocateNewTransactionId();
-        transaction_services.rawStatement(*session,
+        TransactionServices::allocateNewTransactionId();
+        TransactionServices::rawStatement(*session,
                                           *session->getQueryString(),
                                           *session->schema());
         session->my_ok();
@@ -1315,8 +1313,7 @@
 
     session->set_proc_info("end");
 
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.rawStatement(*session,
+    TransactionServices::rawStatement(*session,
                                       *session->getQueryString(),
                                       *session->schema());
     table_list->table= NULL;
@@ -1539,7 +1536,6 @@
 
     This needs to be done before external_lock
   */
-  TransactionServices &transaction_services= TransactionServices::singleton();
 
   /*
    * LP Bug #552420
@@ -1550,8 +1546,7 @@
    */
   to->getMutableShare()->getEngine()->startStatement(session);
 
-  if (!(copy= new CopyField[to->getShare()->sizeFields()]))
-    return -1;
+  copy= new CopyField[to->getShare()->sizeFields()];
 
   if (to->cursor->ha_external_lock(session, F_WRLCK))
     return -1;
@@ -1712,7 +1707,7 @@
       Ensure that the new table is saved properly to disk so that we
       can do a rename
     */
-    if (transaction_services.autocommitOrRollback(*session, false))
+    if (TransactionServices::autocommitOrRollback(*session, false))
       error= 1;
 
     if (not session->endActiveTransaction())

=== modified file 'drizzled/statement/release_savepoint.cc'
--- drizzled/statement/release_savepoint.cc	2011-03-21 22:45:29 +0000
+++ drizzled/statement/release_savepoint.cc	2011-06-23 10:47:03 +0000
@@ -39,13 +39,10 @@
    * find one with the same name, we release it and
    * unbind it from our deque.
    */
-  TransactionServices &transaction_services= TransactionServices::singleton();
   deque<NamedSavepoint> &savepoints= transaction().savepoints;
   deque<NamedSavepoint>::iterator iter;
 
-  for (iter= savepoints.begin();
-       iter != savepoints.end();
-       ++iter)
+  for (iter= savepoints.begin(); iter != savepoints.end(); ++iter)
   {
     NamedSavepoint &sv= *iter;
     const string &sv_name= sv.getName();
@@ -59,7 +56,7 @@
   if (iter != savepoints.end())
   {
     NamedSavepoint &sv= *iter;
-    (void) transaction_services.releaseSavepoint(session(), sv);
+    (void) TransactionServices::releaseSavepoint(session(), sv);
     savepoints.erase(iter);
     session().my_ok();
   }

=== modified file 'drizzled/statement/rename_table.cc'
--- drizzled/statement/rename_table.cc	2011-04-13 10:38:28 +0000
+++ drizzled/statement/rename_table.cc	2011-06-23 10:47:03 +0000
@@ -117,10 +117,7 @@
   /* Lets hope this doesn't fail as the result will be messy */
   if (not error)
   {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.rawStatement(session(),
-                                      *session().getQueryString(),
-                                      *session().schema());        
+    TransactionServices::rawStatement(session(), *session().getQueryString(), *session().schema());        
     session().my_ok();
   }
 

=== modified file 'drizzled/statement/rollback_to_savepoint.cc'
--- drizzled/statement/rollback_to_savepoint.cc	2011-03-21 22:45:29 +0000
+++ drizzled/statement/rollback_to_savepoint.cc	2011-06-23 10:47:03 +0000
@@ -65,7 +65,6 @@
    * all savepoints "above" the one we find.
    */
   deque<NamedSavepoint> &savepoints= transaction().savepoints;
-  TransactionServices &transaction_services= TransactionServices::singleton();
 
   /* Short-circuit for no savepoints */
   if (savepoints.empty())
@@ -88,7 +87,7 @@
                      first_savepoint_name.size()) == 0)
     {
       /* Found the named savepoint we want to rollback to */
-      (void) transaction_services.rollbackToSavepoint(session(), first_savepoint);
+      (void) TransactionServices::rollbackToSavepoint(session(), first_savepoint);
 
       if (transaction().all.hasModifiedNonTransData())
       {
@@ -126,7 +125,7 @@
       /* Found the named savepoint we want to rollback to */
       found= true;
 
-      (void) transaction_services.rollbackToSavepoint(session(), sv);
+      (void) TransactionServices::rollbackToSavepoint(session(), sv);
     }
     if (found)
     {

=== modified file 'drizzled/statement/savepoint.cc'
--- drizzled/statement/savepoint.cc	2011-03-21 22:45:29 +0000
+++ drizzled/statement/savepoint.cc	2011-06-23 10:47:03 +0000
@@ -61,7 +61,6 @@
      * Look through the savepoints.  If we find one with
      * the same name, delete it.
      */
-    TransactionServices &transaction_services= TransactionServices::singleton();
     deque<NamedSavepoint> &savepoints= transaction().savepoints;
     deque<NamedSavepoint>::iterator iter;
 
@@ -81,13 +80,13 @@
     if (iter != savepoints.end())
     {
       NamedSavepoint &sv= *iter;
-      (void) transaction_services.releaseSavepoint(session(), sv);
+      (void) TransactionServices::releaseSavepoint(session(), sv);
       savepoints.erase(iter);
     }
     
     NamedSavepoint newsv(lex().ident.str, lex().ident.length);
 
-    if (transaction_services.setSavepoint(session(), newsv))
+    if (TransactionServices::setSavepoint(session(), newsv))
     {
       return true;
     }

=== modified file 'drizzled/transaction_services.cc'
--- drizzled/transaction_services.cc	2011-06-23 10:21:19 +0000
+++ drizzled/transaction_services.cc	2011-06-23 10:47:03 +0000
@@ -304,11 +304,10 @@
  * is always committed at the end of all statements.
  */
 
-static plugin::XaStorageEngine *xa_storage_engine;
-
-TransactionServices::TransactionServices()
+static plugin::XaStorageEngine& xa_storage_engine()
 {
-  xa_storage_engine= static_cast<plugin::XaStorageEngine*>(plugin::StorageEngine::findByName("InnoDB"));
+  static plugin::XaStorageEngine& engine= static_cast<plugin::XaStorageEngine&>(*plugin::StorageEngine::findByName("InnoDB"));
+  return engine;
 }
 
 void TransactionServices::registerResourceForStatement(Session& session,
@@ -327,7 +326,7 @@
     registerResourceForTransaction(session, monitored, engine);
   }
 
-  TransactionContext *trans= &session.transaction.stmt;
+  TransactionContext& trans= session.transaction.stmt;
   ResourceContext& resource_context= session.getResourceContext(*monitored, 0);
 
   if (resource_context.isStarted())
@@ -338,9 +337,8 @@
 
   resource_context.setMonitored(monitored);
   resource_context.setTransactionalStorageEngine(engine);
-  trans->registerResource(&resource_context);
-
-  trans->no_2pc= true;
+  trans.registerResource(&resource_context);
+  trans.no_2pc= true;
 }
 
 void TransactionServices::registerResourceForStatement(Session& session,
@@ -360,7 +358,7 @@
     registerResourceForTransaction(session, monitored, engine, resource_manager);
   }
 
-  TransactionContext *trans= &session.transaction.stmt;
+  TransactionContext& trans= session.transaction.stmt;
   ResourceContext& resource_context= session.getResourceContext(*monitored, 0);
 
   if (resource_context.isStarted())
@@ -372,14 +370,14 @@
   resource_context.setMonitored(monitored);
   resource_context.setTransactionalStorageEngine(engine);
   resource_context.setXaResourceManager(resource_manager);
-  trans->registerResource(&resource_context);
+  trans.registerResource(&resource_context);
 }
 
 void TransactionServices::registerResourceForTransaction(Session& session,
                                                          plugin::MonitoredInTransaction *monitored,
                                                          plugin::TransactionalStorageEngine *engine)
 {
-  TransactionContext *trans= &session.transaction.all;
+  TransactionContext& trans= session.transaction.all;
   ResourceContext& resource_context= session.getResourceContext(*monitored, 1);
 
   if (resource_context.isStarted())
@@ -387,14 +385,14 @@
 
   session.server_status|= SERVER_STATUS_IN_TRANS;
 
-  trans->registerResource(&resource_context);
+  trans.registerResource(&resource_context);
 
   assert(monitored->participatesInSqlTransaction());
   assert(not monitored->participatesInXaTransaction());
 
   resource_context.setMonitored(monitored);
   resource_context.setTransactionalStorageEngine(engine);
-  trans->no_2pc= true;
+  trans.no_2pc= true;
 
   if (session.transaction.xid_state.xid.is_null())
     session.transaction.xid_state.xid.set(session.getQueryId());
@@ -445,7 +443,7 @@
   }
 
   Session *my_session= current_session;
-  uint64_t xa_id= xa_storage_engine->getNewTransactionId(my_session);
+  uint64_t xa_id= xa_storage_engine().getNewTransactionId(my_session);
   my_session->setXaId(xa_id);
 }
 
@@ -453,7 +451,7 @@
 {
   if (session.getXaId() == 0)
   {
-    session.setXaId(xa_storage_engine->getNewTransactionId(&session)); 
+    session.setXaId(xa_storage_engine().getNewTransactionId(&session)); 
   }
 
   return session.getXaId();

=== modified file 'drizzled/transaction_services.h'
--- drizzled/transaction_services.h	2011-06-23 10:21:19 +0000
+++ drizzled/transaction_services.h	2011-06-23 10:47:03 +0000
@@ -44,18 +44,6 @@
 public:
   static const size_t DEFAULT_RECORD_SIZE= 100;
   
-  TransactionServices();
-
-  /**
-   * Singleton method
-   * Returns the singleton instance of TransactionServices
-   */
-  static inline TransactionServices &singleton()
-  {
-    static TransactionServices transaction_services;
-    return transaction_services;
-  }
-
   /**
    * Returns true if the transaction manager should construct
    * Transaction and Statement messages, false otherwise.
@@ -189,15 +177,15 @@
    * @param query Query string
    * @param schema Schema for the table affected by the raw SQL.
    */
-  void rawStatement(Session&, const std::string &query, const std::string &schema);
+  static void rawStatement(Session&, const std::string &query, const std::string &schema);
 
-  void rawStatement(Session& session, const std::string& query)
+  static void rawStatement(Session& session, const std::string& query)
   {
     rawStatement(session, query, "");
   }
 
   /* transactions: interface to plugin::StorageEngine functions */
-  int rollbackTransaction(Session&, bool all);
+  static int rollbackTransaction(Session&, bool all);
 
   /**
    * Commit the current transaction.
@@ -212,7 +200,7 @@
    * stored functions or triggers. So we simply do nothing now.
    * This should be fixed in later ( >= 5.1) releases.
    */
-  int commitTransaction(Session&, bool all);
+  static int commitTransaction(Session&, bool all);
 
   /**
    * This is used to commit or rollback a single statement depending on
@@ -225,12 +213,12 @@
    * the user has used LOCK TABLES then that mechanism does not know to do the
    * commit.
    */
-  int autocommitOrRollback(Session&, int error);
+  static int autocommitOrRollback(Session&, int error);
 
   /* savepoints */
-  int rollbackToSavepoint(Session&, NamedSavepoint &sv);
-  int setSavepoint(Session&, NamedSavepoint &sv);
-  int releaseSavepoint(Session&, NamedSavepoint &sv);
+  static int rollbackToSavepoint(Session&, NamedSavepoint &sv);
+  static int setSavepoint(Session&, NamedSavepoint &sv);
+  static int releaseSavepoint(Session&, NamedSavepoint &sv);
 
   /**
    * Marks a storage engine as participating in a statement
@@ -250,9 +238,7 @@
    * @param[in] monitored Descriptor for the resource which will be participating
    * @param[in] engine Pointer to the TransactionalStorageEngine resource
    */
-  void registerResourceForStatement(Session&,
-                                    plugin::MonitoredInTransaction *monitored,
-                                    plugin::TransactionalStorageEngine *engine);
+  static void registerResourceForStatement(Session&, plugin::MonitoredInTransaction*, plugin::TransactionalStorageEngine*);
 
   /**
    * Marks an XA storage engine as participating in a statement
@@ -273,7 +259,7 @@
    * @param[in] engine Pointer to the TransactionalStorageEngine resource
    * @param[in] resource_manager Pointer to the XaResourceManager resource manager
    */
-  void registerResourceForStatement(Session&,
+  static void registerResourceForStatement(Session&,
                                     plugin::MonitoredInTransaction *monitored,
                                     plugin::TransactionalStorageEngine *engine,
                                     plugin::XaResourceManager *resource_manager);
@@ -302,16 +288,11 @@
    * time when this method is called except from the
    * TransactionServices::registerResourceForStatement method.
    */
-  void registerResourceForTransaction(Session&,
-                                      plugin::MonitoredInTransaction *monitored,
-                                      plugin::TransactionalStorageEngine *engine);
-
-  void registerResourceForTransaction(Session&,
-                                      plugin::MonitoredInTransaction *monitored,
-                                      plugin::TransactionalStorageEngine *engine,
-                                      plugin::XaResourceManager *resource_manager);
-
-  void allocateNewTransactionId();
+  static void registerResourceForTransaction(Session&, plugin::MonitoredInTransaction*, plugin::TransactionalStorageEngine*);
+
+  static void registerResourceForTransaction(Session&, plugin::MonitoredInTransaction*, plugin::TransactionalStorageEngine*, plugin::XaResourceManager*);
+
+  static void allocateNewTransactionId();
  
   /**************
    * Events API
@@ -325,7 +306,7 @@
    * @retval true Success
    * @retval false Failure
    */
-  bool sendStartupEvent(Session&);
+  static bool sendStartupEvent(Session&);
 
   /**
    * Send server shutdown event.
@@ -335,7 +316,7 @@
    * @retval true Success
    * @retval false Failure
    */
-  bool sendShutdownEvent(Session&);
+  static bool sendShutdownEvent(Session&);
 
 private:
 

=== modified file 'plugin/multi_thread/multi_thread.cc'
--- plugin/multi_thread/multi_thread.cc	2011-06-22 16:36:40 +0000
+++ plugin/multi_thread/multi_thread.cc	2011-06-23 10:47:03 +0000
@@ -78,7 +78,7 @@
     cout << _("In File: ") << *::boost::get_error_info<boost::throw_file>(ex) << endl;
     cout << _("On Line: ") << *::boost::get_error_info<boost::throw_line>(ex) << endl;
 
-    TransactionServices::singleton().sendShutdownEvent(*session.get());
+    TransactionServices::sendShutdownEvent(*session.get());
   }
   // @todo remove hard spin by disconnection the session first from the
   // thread.

